﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread.CellType;

namespace AutoSizeComboBoxCellTypeColumn_CSharp
{
    public partial class Form1 : Form
    {
        ComboBoxCellType cmbCountry = null;
        ComboBoxCellType cmbLang = null;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            //
            //Set the Label of ColumnHeader
            //
            fpSpread1.ActiveSheet.ColumnHeader.Columns[0].Label = "Name";
            fpSpread1.ActiveSheet.ColumnHeader.Columns[1].Label = "Language";
            fpSpread1.ActiveSheet.ColumnHeader.Columns[2].Label = "Country";

            //
            //Create ComboBoxCellType
            //
            cmbCountry = new ComboBoxCellType();
            cmbLang = new ComboBoxCellType();
     

            cmbCountry.Items = new string[] { "India", "South Australia", "China", "USA" };
            cmbLang.Items = new string[] { "Hindi-India(IN)", "English-Australia(AU)", "Urdu-PK", "Chinese-ZN" };

            //
            // Set the CellType to ComboBoxCellType
            //
            for (int row = 0; row < 6; row++)
            {
                fpSpread1.ActiveSheet.Cells[row,1].CellType = cmbLang;
                fpSpread1.ActiveSheet.Cells[row, 2].CellType = cmbCountry;
            }

            //
            //Fill data in Spread Sheet
            //

            fpSpread1.ActiveSheet.Cells[0, 0].Text = "Jack";
            fpSpread1.ActiveSheet.Cells[1, 0].Text = "Denial";
            fpSpread1.ActiveSheet.Cells[2, 0].Text = "Johnson Andrew";
            fpSpread1.ActiveSheet.Cells[3, 0].Text = "John Peter";
            fpSpread1.ActiveSheet.Cells[4, 0].Text = "John cena";
            fpSpread1.ActiveSheet.Cells[5, 0].Text = "John A";


            fpSpread1.ActiveSheet.Columns[0].Width = fpSpread1.ActiveSheet.GetPreferredColumnWidth(0);
            fpSpread1.ActiveSheet.Columns[2].Width = getWidth();
            fpSpread1.ComboCloseUp += new FarPoint.Win.Spread.EditorNotifyEventHandler(fpSpread1_ComboCloseUp);

        }
        //
        //Set the Width of Column 2 based on selected item's Width
        //
        void fpSpread1_ComboCloseUp(object sender, FarPoint.Win.Spread.EditorNotifyEventArgs e)
        {
            if (e.Column == 1 && fpSpread1.ActiveSheet.ActiveCell.Text!=string.Empty)
            {
                cmbLang.StopEditing();
                fpSpread1.ActiveSheet.Columns[1].Width = fpSpread1.ActiveSheet.GetPreferredColumnWidth(1);
            }
        }
        //
        //Set the Width of Column 3 based on longest item's Width
        //
        float getWidth()
        {
            float _fTotalWidth = 0;
            for (int _iCount = 0; _iCount < cmbCountry.Items.Count(); _iCount++)
            {
                if (_fTotalWidth < this.CreateGraphics().MeasureString(cmbCountry.Items[_iCount], new Font("Microsoft Sans Serif", 8.25f)).Width)
                {
                    _fTotalWidth = this.CreateGraphics().MeasureString(cmbCountry.Items[_iCount], new Font("Microsoft Sans Serif", 8.25f)).Width;
                }
            }
            _fTotalWidth = _fTotalWidth + SystemInformation.VerticalScrollBarWidth;
            return _fTotalWidth;
        }
    }
}
